#include <iostream>
#include "m2x2.h"
#include "circle.h"
#include "seg2d.h"

using namespace std;

int main() {


  V2 r0(3.0f, -2.0f);
  V2 r1(-1.0f, 7.0f);
  M2x2 m0(r0, r1);

  V2 r2(10.0f, 2.0f);
  V2 r3(2.0f, 2.0f);
  M2x2 m1(r2, r3);

  M2x2 m = m0*m1;

  cout << "m rows:" <<endl;
  cout << m[0] << m[1] << endl;

  cout << "m: "<<endl;
  cout << m << endl;

  cout << "m columns:"<<endl;
  cout << m.Column(0) << m.Column(1) << endl;

  cout << "m transpose:"<<endl;
  cout << m.Transpose() << endl;

  cout << "m: "<<endl;
  cout << m << endl;

  cout << "0 deg rotation matrix" << endl;
  cout << M2x2(0) << endl;

  cout << "90 deg rotation matrix" << endl;
  cout << M2x2(90) << endl;

  Seg2D s1(V2(0,0),V2(1,1));
  Seg2D s2(V2(0,1),V2(1,0));
  V2 inter;
 
  if(s1.Intersect(s2,inter)) {
    cout << "s1, s2 intersection point = " <<  inter << endl;
  }
  else {
    cout << "s1, s2 do not intersect" << endl;
  }

  Seg2D s3(V2(0,0),V2(1,1));
  Seg2D s4(V2(0,1),V2(1,2));
 
  if(s3.Intersect(s4,inter)) {
    cout << "s3, s4 intersection point = " <<  inter << endl;
  }
  else {
    cout << "s3, s4 do not intersect" << endl;
  }
 
  cout << "s4 length = " << s4.Length() << endl;

  Seg2D s5(V2(0,0),V2(1,1));
  Seg2D s6(V2(0,10),V2(10,0));
 
  if(s5.Intersect(s6,inter)) {
    cout << "s5, s6 intersection point = " <<  inter << endl;
  }
  else {
    cout << "s5, s6 do not intersect" << endl;
  }

  return 0;
}
